<template>
	<div class="statistics-order-accept-top-ten-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<div class="table-search-content">
				<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline>
					<el-form-item prop="crTime">
						<statistical-time v-model="state.queryParams.crTime" @change="handleQuery" ref="statisticalTimeRef" :disabled="state.loading" />
					</el-form-item>
					<el-form-item>
						<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
						<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
							<SvgIcon name="ele-Refresh" class="mr5" />重置
						</el-button>
					</el-form-item>
				</el-form>
			</div>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-grid v-bind="gridOptions"> </vxe-grid>
			</div>
		</div>
	</div>
</template>
<script setup lang="tsx" name="statisticsOrderAcceptTop10">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { departmentTopTenExport, departmentTopTenNew } from '@/api/statistics/order';
import { defaultDate } from '@/utils/constants';
import Other from '@/utils/other';
import XEUtils from 'xe-utils';

const StatisticalTime = defineAsyncComponent(() => import('@/components/StatisticalTime/index.vue')); // 日期类型选择组件
// 定义变量内容
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive<any>({
	queryParams: {
		// 查询条件
		crTime: defaultDate,
		StartTime: null,
		EndTime: null,
	},
	loading: false, // 加载
});
/** 搜索按钮操作 */
const handleQuery = () => {
	// state.queryParams.PageIndex = 1;
	queryList();
};
const requestParams = ref<EmptyObjectType>({});
const gridOptions = reactive<any>({
	loading: false,
	border: true,
	showOverflow: true,
	printConfig: {},
	columnConfig: {
		resizable: true,
	},
	scrollY: {
		enabled: true,
		gt: 100,
	},
	toolbarConfig: {
		zoom: true,
		custom: true,
		refresh: {
			queryMethod: () => {
				queryList();
			},
		},
		tools: [{ toolRender: { name: 'exportAll' } }],
	},
	customConfig: {
		storage: true,
	},
	id: 'statisticsOrderAcceptTop10',
	rowConfig: { isHover: true, height: 30, isCurrent: true,useKey:true },
	height: 'auto',
	columns: [],
	data: [],
	showFooter: true,
	footerMethod: ({ columns, data }) => {
		return [
			columns.map((column: any, columnIndex: number) => {
				if (columnIndex === 0) {
					return '合计';
				}
				return XEUtils.sum(data, column.property);
			}),
		];
	},
	params: {
		exportMethod: departmentTopTenExport,
		exportParams: requestParams,
	},
});
/** 获取列表 */
const queryList = () => {
	state.loading = true;
	gridOptions.loading = true;
	requestParams.value = Other.deepClone(state.queryParams);
	requestParams.value.StartTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[0]; // 生成时间
	requestParams.value.EndTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[1];
	Reflect.deleteProperty(requestParams.value, 'crTime'); // 删除无用的参数
	departmentTopTenNew(requestParams.value)
		.then((res: any) => {
			let columns = res.result.list?.map((item: any) => {
				return {
					prop: item.dicDataName,
					label: item.dicDataName,
					align: 'center',
					field: item.dicDataName,
					title: item.dicDataName,
					minWidth: 90,
					sortable: true,
				};
			});
			columns.unshift(
				{
					prop: '省一级热点名称',
					label: '省一级热点名称',
					field: '省一级热点名称',
					title: '省一级热点名称',
					minWidth: 90,
					align: 'center',
				},
				{
					prop: '有效受理量',
					label: '有效受理量',
					field: '有效受理量',
					title: '有效受理量',
					minWidth: 90,
					sortable: true,
					align: 'center',
				}
			);
			gridOptions.columns = columns;
			// 计算横轴小计
			gridOptions.data = res.result?.data;
			state.loading = false;
			gridOptions.loading = false;
		})
		.catch(() => {
			state.loading = false;
			gridOptions.loading = false;
		});
};
/** 重置按钮操作 */
const statisticalTimeRef = ref<RefType>();
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	statisticalTimeRef.value.reset();
	queryList();
};
onMounted(() => {
	queryList();
});
</script>
